
window.addEventListener("load",function() {initAutoCopyLiteStatus();} ,false);
window.addEventListener("focus",function() {resetAutoCopyLiteStatus();} ,false);



function initAutoCopyLiteStatus() 
{

        initPreferencesLite();

	document.getElementById("cmd_selectAll").setAttribute("oncommand", "goDoCommand('cmd_selectAll'); AutocopyLiteSelectAll();");

    	var strings = document.getElementById("autocopyliteStrings");

	var autocopyliteLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{3CD6C1B9-F684-4b32-B0D1-BB1E8A4E6D6B}.");
	var autocopylitelocaledescription = strings.getString("autocopylite-description");
	var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
	str.data = autocopylitelocaledescription;
	autocopyliteLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );


}



function resetAutoCopyLiteStatus()
{
    initAutoCopyLiteStatus()
}




function initPreferencesLite(){

	if (!autocopylitePrefs.prefHasUserValue("optAutocopyEnabled"))
		autocopylitePrefs.setIntPref("optAutocopyEnabled", true);
	if (!autocopylitePrefs.prefHasUserValue("optPasteOnMiddleClick"))
		autocopylitePrefs.setBoolPref("optPasteOnMiddleClick", true);
	if (!autocopylitePrefs.prefHasUserValue("optDeselectAfterCopy"))
	{
		if(navigator.vendor.match(/Thunderbird/i))
		{
			autocopylitePrefs.setBoolPref("optDeselectAfterCopy", false);
		}
		else
		{
			autocopylitePrefs.setBoolPref("optDeselectAfterCopy", true);
		}
	}
	if (!autocopylitePrefs.prefHasUserValue("optEnableInTextBoxes"))
		autocopylitePrefs.setBoolPref("optEnableInTextBoxes", false);

}


// prefs
var autocopylitePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopylite.");

if (!autocopylitePrefs.prefHasUserValue("optAutocopyEnabled"))
	autocopylitePrefs.setBoolPref("optAutocopyEnabled", true)


window.onmouseup = autocopyliteOnMouseUp;
window.onkeyup = onKeyUpChecklite;


function onKeyUpChecklite(e)
{
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		autocopyliteOnMouseUp(e);
	}
}


function autocopyliteOnMouseUp(e){
   
   var targetclassname = e.target.toString();
   if(autocopylitePrefs.getBoolPref("optAutocopyEnabled")){
	if (!targetclassname.match(/object XUL/i) || (e.target.id.match(/addressCol|msgSubject|expanded.*Box|searchInput/) || autocopylitePrefs.getBoolPref("optEnableInTextBoxes")))
	{
		if(!targetclassname.match(/SelectElement|OptionElement/i))
		{
			if(!targetclassname.match(/InputElement|TextAreaElement/i) || autocopylitePrefs.getBoolPref("optEnableInTextBoxes"))
			{
				goDoCommand('cmd_copy');
				if(autocopylitePrefs.getBoolPref("optDeselectAfterCopy"))
				{
					goDoCommand('cmd_selectNone');
				}
			}
		}
	}
   }

   if(autocopylitePrefs.getBoolPref("optPasteOnMiddleClick"))
   {
	if(e.button == 1)
	{
		var doPaste = false;
		if(e.target.toString().match(/HTML.*Element/i))
		{
			if(!e.target.toString().match(/HTMLAnchorElement/i))
			{
				doPaste = true;
			}
			if(e.target.toString().match(/HTMLImageElement/i))
			{
				if(e.target.src.match(/chrome\:\/\/.*autoscroll/i))
				{
					doPaste = true;
				}
			}
		}

		if(e.target.inputField)
		{
			if(e.target.inputField.toString().match(/InputElement|TextAreaElement/i))
			{
				doPaste = true;
			}
		}

		if(e.target.mTextbox)
		{
			if(e.target.mTextbox.inputField)
			{
				if(e.target.mTextbox.inputField.toString().match(/InputElement|TextAreaElement/i))
				{
					doPaste = true;
				}
			}
		}

		if(doPaste)
		{
			goDoCommand('cmd_paste');
		}
	}
    }
}


function AutocopyLiteSelectAll(){
   if(autocopylitePrefs.getBoolPref("optAutocopyEnabled"))
   {
	goDoCommand('cmd_copy');
	if(autocopylitePrefs.getBoolPref("optDeselectAfterCopy"))
	{
		goDoCommand('cmd_selectNone');
	}
   }
}


